#include <GyverTimer.h>

#include <GyverUART.h>

#include <GyverTimer.h>

#include <GyverUART.h>

#include <GyverTimer.h>
#include <GyverUART.h>
#include <microLiquidCrystal_I2C.h>
#include <microWire.h>
#include <sav_button.h>

//            Контроллер лампового усилителя мощности
//        измеритель мощности и КСВ, тока и напряжения анода
//                тока и напряжения второй сетки
//                      UT0IS/D0ISM, 02/2020
//
//  v.1.0.2 - сделал прямой доступ к аналоговым портам
//  v.1.0.3 - подключение кнопки S1 - ON/OFF
//  длинное нажатие S1 - включение, повторное нажатие - выключение
//  введен алгоритм подачи напряжения при включении
//  введен алгоритм снятия напряжений с ламп(ы) при выключении
//  применено два раздельных счетчика на нагрев и охлаждение
//  v.1.0.4 - подключил датчик температуры DS18B20
//  при коротком нажатии кнопки S1 в нижней строке отображается температура
//  и время от мемента включения усилителя
//  повторное нажатие кнопки возвращает индикацию
//  убрал баг в отображении остаточных значений от преобразования АЦП
//  улучшил алгоритм отрисовки градусника, должен работать чуть быстрее
//  v.1.0.5 - подключил функцию гашения подсветки индикатора, если в
//  течении некоторого времени отсутствовал сигнал прямой волны
//  Если сигнал появляется, подсветка автоматически включается
//  При более длительном отсутствии сигнала прямой волны контроллер
//  автоматически переводит усилитель в Bypass, соблюдая всю последовательность
//  отключения напряжений
//  v.1.0.6 - введена защита от высокого КСВ, порог срабатывания регулируется
//  параметром SWR_HI, при этом отключаются напряжение экранной сетки и 
//  анодного напряжения. Короткое нажатие кнопки S1 возвращает рабочий режим
//  усилителя, включаются анодное и экранное напряжения.
//  Каждое короткое нажатие обнуляет таймер режима сна TIME_SLEEP.
//  v.1.0.7 - введен для удобства обратный таймер для режимов нагрева и охлаждения
//  Надпись высокого КСВ HI переделана на HIGH
//  Введена защита блокировки экранного напряжения при просадке/исчезновения
//  анодного напряжения как при нагреве, так и в работе усилителя
//  Изменена защита от высокого КСВ, отключается только экранное напряжение
//  Сброс защиты происходит по короткому нажатию кнопки S1, при этом 
//  подключается экранное напряжение
//  v.1.0.8 - введено автоматическое определение диапазона по частоте
//  излучаемого сигнала, при этом формируются сигналы для дешифратора
//  диапазонов. В память сохраняется последний рабочий диапазон и частота.
//  При включении контроллера загружается последний рабочий диапазон.
//  Введен цифровой VOX, при наличии сигнала высокой частоты
//  формируется сигнал PTT для перехода усилителя на передачу. Сигнал PTT
//  снимается с задержкой VOXDelay, которую можно подобрать индивидуально.
//  Внедрена задержка DELAY_SWITCH сигнала PTT, если новый диапазон отличается от
//  предыдущего для переключения контактов реле. Переделан бипер и сигнал аварии.
//  Продублирована защита от высокого КСВ и пропадания/снижения анодного напряжения.
//  При этом блокируется сигнал передачи PTT.
//  v.1.0.9CG - версия для каскадов с общими сетками/сеткой
//  Убран контроль напряжения второй сетки и связанные с ней защиты
//  Перераспределил на свободных портах выхода для дешифратора, сигнал бипера, выход PTT,
//  сигнал аварии по высокому КСВ. Ввел новую кнопку S2-Menu. Сделал меню настроек,
//  вход - длинное нажатие S2. Переход по пунктам меню - длинное нажатие S1 или S2,
//  изменение параметров - короткое нажатие s1 или s2. Выход из режима меню - 
//  переход вверх из последнего пункта меню. 
//  Сделал дополнительный выход из меню, если идти вниз от 1-го пункта меню.
//  Добавил ручное переключение диапазонов. Короткое нажатие s1 - диапазон вниз,
//  короткое нажатие s2 - диапазон вверх. Переключение диапазонов по кольцу.
//  Диапазоны можно переключать как в основном режиме, так и в байпасе.
//  Добавил автомасштабирование градусника по мощности. 
//  При изменении значения максимальной выходной мощности в меню, градусник принимает 
//  новое значение на всю длину.
//  Перераспределил ячейки памяти, основные параметры начинаются с адреса 4.
//  v.1.1CG - добавлено автомасштабирование тока сетки. Добавлена возможность
//  выбора внутренного опорного напряжения (1.1В) в параметрах REFERENCE.
//  В отсутствии сигнала от датчика КСВ выводится надпись WAIT.
//  v.1.1 - версия для каскадов с ОК. Введена защита от пропадания анодного напряжения
//  или снижения уровня до удвоенного значения экранного. Также при высоком значении КСВ
//  отключается экранное напряжение, блокируя работу усилителя мощности. Сброс аварии от
//  высокого КСВ снимается кнопкой s1 (короткое нажатие).
//  v.1.2 - сделал отдельную папку src для используемых библиотек.
//  За 15 секунд до запуска режима сна включается предупредительная сигнализация.
//  Изменил алгоритм работы градусника, шаг уменьшения градусника автоматически
//  вычисляется от уровня входного сигнала и максимальным значением, устанавливаемым
//  в меню настроек.
//  Изменил отображение значения выходной мощности, фиксация пиковых значений.
//  Улучшил работу алгоритма определения частоты и системы ВЧ VOX.
//  На порту D2 сделал вход от внешнего управления.
//  v.1.2.1CG - переделан измеритель мощности. Теперь программа учитывает измерение
//  мощности по формуле P=U*U/R и просчитывает напряжение на нагрузке, также автоматически
//  просчитывается коэф. k для определения напряжения на нагрузке, в зависимости от 
//  выбранной мощности шкалы. Фиксация пиковых значений мощности. Также переделан КСВ-метр.
//  Фиксация пиковых значений КСВ устраняет перемаргивания значений.

#include "src/GyverUART.h"                                                          // библиотека последовательного порта
#include "src/GyverTimer.h"                                                         // библиотека таймера
GTimer beep   (MS);                                                                 // таймер бипера
GTimer error  (MS);                                                                 // таймер сигнала аварии
#include <EEPROM.h>                                                                 // библиотека EEPROM
#include "src/microLiquidCrystal_I2C.h"                                             // библиотека microLiquidCrystal_I2C.h
#include "src/sav_button.h"                                                         // подключаем кнопки
SButton button1(0,20,250,0,0);                                                      // кнопка 1 порт D0, короткое нажатие 20мс, длинное нажатие 250мс
SButton button2(1,20,250,0,0);                                                      // кнопка 2 порт D1, короткое нажатие 20мс, длинное нажатие 250мс
LiquidCrystal_I2C lcd(0x27,20,4);                                                   // указываем адрес I2C и размерность дисплея

#define PTT_IN          2                                                           // номер порта сигнала PTT_IN
#define SCREEN          3                                                           // порт D3 вкл./откл. напряжения второй сетки
#define TX              4                                                           // номер порта сигнала PTT
#define FREQ            5                                                           // номер порта входа частотомера
#define D0              6                                                           // выход порта дешифратора D0
#define D1              7                                                           // выход порта дешифратора D1
#define D2              8                                                           // выход порта дешифратора D2
#define D3              9                                                           // выход порта дешифратора D3
#define ANOD            10                                                          // порт D10 вкл./откл. напряжения анода
#define GLOW            11                                                          // порт D11 вкл./откл. накала ламп
#define FAN             12                                                          // порт D12 вкл./откл. вентилятора охлаждения
#define SOUND           13                                                          // номер порта бипера сигнализации высокого КСВ

#define dotimes(n,code) for (int i=0; i<(n); ++i) code;                             // цикл вывода текста заставки
#define text1 " Power Control Unit "                                                // 1-я строка заставки
#define text2 "  SWR & PWR  meter  "                                                // 2-я строка заставки
#define text3 "   D0ISM & RK9AMX   "                                                // 3-я строка заставки
#define text4 "   ver.1.2.1 2021   "                                                // 4-я строка заставки
#define UART_CONNECT_TIME 1000                                                      // время проверки подключения порта по UART

  uint16_t  timer;                                                                  // таймер нагрева/охлаждения
  uint16_t  timer2;                                                                 // таймер ухода в Bypass
  uint8_t   symbol1[8] = {00,00,16,16,16,16,00,00};                                 // определяем символ 1 для "одна палка" прямой волны 
  uint8_t   symbol2[8] = {00,00,20,20,20,20,00,00};                                 // определяем символ 2 для "две палки" прямой волны
  uint8_t   symbol3[8] = {00,00,21,21,21,21,00,00};                                 // определяем символ 3 для "три палки" прямой волны

  uint8_t   LT[8] = {07,15,31,31,31,31,31,31};                                      // сегменты цифр
  uint8_t   UB[8] = {31,31,31,00,00,00,00,00};                                      // -------------
  uint8_t   RT[8] = {28,30,31,31,31,31,31,31};                                      // -------------
  uint8_t   LL[8] = {31,31,31,31,31,31,15,07};                                      // -------------
  uint8_t   LB[8] = {00,00,00,00,00,31,31,31};                                      // -------------
  uint8_t   LR[8] = {31,31,31,31,31,31,30,28};                                      // -------------
  uint8_t   UMB[8] ={31,31,31,00,00,00,31,31};                                      // -------------
  uint8_t   LMB[8] ={31,00,00,00,00,31,31,31};                                      // -------------
  uint32_t  last_uart_time;                                                         // счетчик времени проверки на открытие порта по UART
  uint32_t  VoxMillis;                                                              // счетчик времени задержки PTT
  uint32_t  delay_band;                                                             // задержка переключения диапазонов
  int8_t    h, m, s;                                                                // значение часов, минут, секунд таймера обратного отсчета
  uint8_t   new_sec, old_sec, sec, minut, chas;                                     // переменные времени хода часов
  uint8_t SWRcount;                                                                 // счетчик задержки показания КСВ
  float     SWR=1,SWRpk;                                                            // переменные КСВ
  float     k, Vf;                                                                  // коэф. тр. Tandem Match, напряжение на нагрузке 50Ом
  
  uint16_t  PWRMax;                                                                 // переменная максимальной выходной мощности, Вт
  uint8_t   PWRStep;                                                                // переменная округления шага выходной мощности
  uint16_t  U_ANOD_MAX;                                                             // переменная максимального значения анодного напряжения, В
  uint8_t   U_ANOD_ROUND;                                                           // переменная округления шага анодного напряжения
  uint16_t  I_ANOD_MAX;                                                             // переменная максимального значения анодного тока, мА
  uint8_t   I_ANOD_ROUND;                                                           // переменная округления шага анодного тока
  uint16_t  U_GRID2_MAX;                                                            // переменная максимального значения напряжения второй сетки, В
  uint8_t   U_GRID2_ROUND;                                                          // переменная округления шага напряжения второй сетки
  uint16_t  I_GRID_MAX;                                                             // переменная максимального значения тока сетки, мА
  uint8_t   I_GRID_ROUND;                                                           // переменная округления шага тока сетки
  uint8_t   TIME_ON;                                                                // переменная времени включения/нагрева
  uint8_t   TIME_OFF;                                                               // переменная времени отключения/охлаждения
  uint8_t   TIME_LIGHT;                                                             // переменная времени подсветки индикатора, мин
  uint8_t   TIME_SLEEP;                                                             // переменная времени задержки в спящий режим, мин
  uint8_t   STEP,STEPmax;                                                           // переменная шага уменьшения градусника
  uint8_t   UPDATE_BAR;                                                             // переменная времени обновления состояния градусника, мс
  uint8_t   SWR_HI;                                                                 // переменная значения высокого КСВ
  uint8_t   VOXDelay;                                                               // переменная времени задержки сигнала PTT, мс
  uint8_t   DELAY_SWITCH;                                                           // переменная времени задержки на переключение реле диапазонов, мс
  int8_t    REFERENCE;                                                              // переменная опорного напряжения
  
  uint16_t  PWR,PWRpk;                                                              // переменные мощности
  uint8_t   PWRcount;                                                               // счетчик задержки показания пиковой мощности
  uint16_t  Ua;                                                                     // переменная анодного напряжения
  uint16_t  Ugrid2;                                                                 // переменная экранного напряжения
  uint16_t  Ia;                                                                     // переменная тока анода
  uint16_t  Igrid;                                                                  // переменная тока второй сетки
  uint16_t  Upk;                                                                    // переменная пикового уровня
  uint16_t  valvox;                                                                 // переменная счета отпускания VOX
  bool      power=0;                                                                // флаг питания
  bool      flag_cool=0;                                                            // флаг режима охлаждения
  bool      flag_swr_hi=0;                                                          // флаг высокого КСВ
  bool      flag_band=0;                                                            // флаг ручного переключения диапазонов
  bool      flag_Ua=0;                                                              // флаг наличия анодного напряжения  
  bool      bypass=0;                                                               // флаг режима обхода
  bool      flag_time;                                                              // флаг индикации времени
  uint8_t   band;                                                                   // переменная переключения диапазонов
  uint8_t   band_get;                                                               // переменная выбора диапазонов
  uint16_t  frq, frq_get;                                                           // переменная входной частоты и частоты диапазона
  uint16_t  frq_old1, frq_old2, frq_old3;                                           // переменные промежуточных частот для вычисления частоты диапазона
  word      frqbuf;                                                                 // значение частоты для сохранения в память
  
  uint8_t analog_ref;                                                               // опорное напряжение
  volatile uint16_t ReadUa, ReadIa, ReadUgrid2, ReadIgrid, ReadUfor, ReadUrev;      // переменные напр. анода, тока анода, напр. второй сетки, тока второй сетки, пр. и обр. волны
  volatile uint8_t analogPin = A0;                                                  // начальный аналоговый пин А0
  volatile bool trueValue = false;                                                  // флаг разрешения прерывания АЦП

  volatile unsigned long timerCounts;                                               // таймер счетчика
  volatile bool counterReady;                                                       // флаг готовности счетчика
  unsigned long overflowCount;                                                      // счетчик переполнений
  unsigned int  timerTicks;                                                         // счетчик тиков
  unsigned int  timerPeriod;                                                        // продолжительность периода измерения

  uint8_t commandByte[15];                                                          // буфер UART команды 
  uint8_t connect_to_pc;                                                            // флаг установки соединения с ПК
  uint8_t config_loop;                                                              // флаг входа в процедуру обмена по UART
//*********************************************************************************** Подпрограмма частотомера
void startCounting (unsigned int ms){ 
    counterReady= false;                                                            // готовность счётчика
    timerPeriod = ms;                                                               // количество импульсов на входе за 1 мс
    timerTicks  = 0;                                                                // сброс счетчика тиков
    overflowCount = 0;                                                              // сброс счётчика переполнений
    TCCR1A=0; TCCR1B=0; TCCR2A=0; TCCR2B=0;                                         // сброс таймера 1 и таймера 2
    TIMSK1=bit(TOIE1);                                                              // таймер 1-подсчет импульсов на pin D5, прерывание при переполнении таймера 1
    TCCR2A=bit(WGM21) ;                                                             // режим CTC
    OCR2A=124;                                                                      // подсчёт 125 тиков для получения 1мс (корректировка показаний)
    TIMSK2= bit(OCIE2A);                                                            // timer 2-прерывание каждую 1 мс, включаем прерывание Timer2
    TCNT1=0; TCNT2=0;                                                               // сброс счётчиков 1 и 2
    GTCCR=bit(PSRASY);                                                              // сброс предделителя, таймер 2
    TCCR2B=bit(CS20)|bit(CS22);                                                     // предделитель на 128, запуск таймера 1
    TCCR1B=bit(CS10)|bit(CS11)|bit(CS12);}                                          // чтение частоты на T1 пин D5
    ISR (TIMER1_OVF_vect){++overflowCount;}                                         // подсчет числа переполнения счетчика 1, конец TIMER1_OVF_vect                             
    ISR (TIMER2_COMPA_vect){                                                        // таймер 2 прерываний запускается аппаратным таймером 1 каждую 1мс
    unsigned int timer1CounterValue;                                                // получить значение счетчика,перед его изменением
    timer1CounterValue=TCNT1;                                                       // считываем частоту с регистров
    unsigned long overflowCopy=overflowCount;                                       // 
  if (++timerTicks<timerPeriod) return;                                             //
  if ((TIFR1 & bit(TOV1)) && timer1CounterValue < 256) overflowCopy++;              // при переполнении
    TCCR1A=0; TCCR1B=0;                                                             // обнуляем таймер 1
    TCCR2A=0; TCCR2B=0;                                                             // обнуляем таймер 2
    TIMSK1=0; TIMSK2=0;                                                             // отключаем прерывания на Timer1 и Timer2
    timerCounts = (overflowCopy << 16) + timer1CounterValue;                        // подсчёт переполнений, каждое переполнение больше 65536
    counterReady=true;}                                                             // устанавливаем флаг готовности для следующего подсчета

void setup(){//********************************************************************************************
    ADC_init();                                                                     // инициализация аналоговых портов
    uart.begin();                                                                   // инициализация UART (аналог стандартной функции Serial)
    beep.setTimeout (50);                                                           // длительность сигнала бипера, мс
    error.setTimeout(750);                                                          // длительность сигнала аварии, мс
    button1.begin();                                                                // инициализация кнопки 1
    button2.begin();                                                                // инициализация кнопки 2
    lcd.init();                                                                     // производим инициализацию дисплея
    lcd.backlight();                                                                // включаем подсветку
    
    pinMode(PTT_IN, INPUT_PULLUP);                                                  // порт PTT_IN на вход
    pinMode(TX,     OUTPUT);                                                        // порт TX на выход
    pinMode(FREQ,   INPUT);                                                         // порт FREQ на вход
    pinMode(SOUND,  OUTPUT);                                                        // порт SOUND на выход
    pinMode(D0,     OUTPUT);                                                        // вывод D0 на выход, подключение дешифратора 8 вывод
    pinMode(D1,     OUTPUT);                                                        // вывод D1 на выход, подключение дешифратора 9 вывод
    pinMode(D2,     OUTPUT);                                                        // вывод D2 на выход, подключение дешифратора 10 вывод
    pinMode(D3,     OUTPUT);                                                        // вывод D3 на выход, подключение дешифратора 11 вывод
    pinMode(FAN,    OUTPUT);                                                        // порт FAN на выход
    pinMode(GLOW,   OUTPUT);                                                        // порт GLOW на выход
    pinMode(ANOD,   OUTPUT);                                                        // порт ANOD на выход
    pinMode(SCREEN, OUTPUT);                                                        // порт SCREEN на выход
    Wire.setClock  (800000);                                                        // установка частоты шины I2C 400/800 кГц
    
    lcd.setCursor(0, 1);                                                            // курсор в позицию 0,1
    lcd.print("  PC Connecting...  ");                                              // выводим на экран "  PC Connecting...  "
    last_uart_time = millis();                                                      // выравниваем переменную счетчика времени проверки на открытие порта
while (millis() - last_uart_time < UART_CONNECT_TIME) {                             // запускаем цикл на время константы UART_CONNECT_TIME
  if (uart.available() > 0) {                                                       // если данные в буфере больше 0
    lcd.setCursor(0, 0); lcd.print(" Configuration Mode ");                         // в позиции 0,0 выводим " Configuration Mode "
    lcd.setCursor(0, 1); lcd.print(" Connecting to PC...");                         // в позиции 0,1 выводим " Connecting to PC..."
    settings_uart();}}                                                              // запускаем подпрограмму чтения/записи в последовательный порт
    lcd.clear();                                                                    // очищаем экран
  
  if (digitalRead(1)==LOW){                                                         // при включении питания с удержанием кнопки на D1
    lcd.setCursor(0,0); lcd.print("    MEMORY RESET    ");                          // выводим надпись "MEMORY RESET"
while (digitalRead(1)==LOW){}                                                       // ждём отпускания кнопки 
  for (int i=0; i<100; i++){delay(100); EEPROM.update(i,0);                         // включаем цикл перебора обнуляемых ячеек памяти
    lcd.setCursor(9,1); lcd.print(i);} delay(500); lcd.clear();}                    // выводим номер обнуляемой ячейки, задержка 500мс, очистка индикатора
    
    band_get = EEPROM.read(0);                                                      // читаем из памяти информацию о последнем диапазоне перед выключением
    band = band_get;                                                                // приравниваем переменные переключения и выбора диапазонов
  if ((isnan(band_get) == true) || ((band_get < 1) || (band_get > 9))){             // проверяем на нечисло диапазон, рабочий диапазон 1-9
    EEPROM.update(0,5); band_get = EEPROM.read(0); band = band_get;}                // пишем в память 5-й диапазон, переносим его в переменные диапазона    
    
    frqbuf = word (EEPROM.read(1), EEPROM.read(2));                                 // читаем из памяти последнюю частоту
  if ((isnan(frqbuf) == true) || ((frqbuf < 16) || (frqbuf > 300))){                // проверяем на нечисло частоту, рабочая частота 1.7-30.0МГц
    EEPROM.update(1, highByte(141)); EEPROM.update(2, lowByte(141));                // пишем в память частоту 14.1МГц
    frqbuf = word (EEPROM.read(1), EEPROM.read(2));}                                // читаем новое значение в переменную

    PWRMax = word (EEPROM.read(4), EEPROM.read(5));                                 // читаем из памяти значение максимальной мощности
  if ((isnan(PWRMax) == true) || ((PWRMax < 100)|| (PWRMax > 10000))){              // проверяем на нечисло и если мощность меньше 100Вт или больше 10000Вт
    EEPROM.update(4, highByte(1000)); EEPROM.update(5, lowByte(1000));              // пишем в память 1000Вт
    PWRMax = word (EEPROM.read(4), EEPROM.read(5));}                                // читаем новое значение в переменную
    
    PWRStep = EEPROM.read(6);                                                       // читаем из памяти шаг округления показания мощности
  if ((isnan(PWRStep) == true) || ((PWRStep < 10) || (PWRStep > 100))){             // проверяем на нечисло и если шаг мощности меньше 10 или больше 100
    EEPROM.update(6,20); PWRStep = EEPROM.read(6);}                                 // пишем в память 20 и читаем новое значение в переменную

    U_ANOD_MAX = word (EEPROM.read(8), EEPROM.read(9));                             // читаем из памяти максимальное значение анодного напряжения
  if ((isnan(U_ANOD_MAX) == true) || ((U_ANOD_MAX < 100) || (U_ANOD_MAX > 10000))){ // проверяем на нечисло и если значение меньше 100 или больше 10000
    EEPROM.update(8, highByte(3000)); EEPROM.update(9, lowByte(3000));              // пишем в память 3000
    U_ANOD_MAX = word (EEPROM.read(8), EEPROM.read(9));}                            // читаем новое значение в переменную

    U_ANOD_ROUND = EEPROM.read(10);                                                 // читаем из памяти значение шага округления анодного напряжения
  if ((isnan(U_ANOD_ROUND) == true)||((U_ANOD_ROUND < 1)||(U_ANOD_ROUND > 100))){   // проверяем на нечисло и если шаг округления меньше 1 или больше 100
    EEPROM.update(10,20); U_ANOD_ROUND = EEPROM.read(10);}                          // пишем в память 20 и читаем новое значение в переменную

    I_ANOD_MAX = word (EEPROM.read(12), EEPROM.read(13));                           // читаем из памяти значение максимального тока анода в мА
  if ((isnan(I_ANOD_MAX) == true) || ((I_ANOD_MAX < 10) || (I_ANOD_MAX > 5000))){   // проверяем на нечисло и если значение меньше 10 или больше 5000
    EEPROM.update(12, highByte(1000)); EEPROM.update(13, lowByte(1000));            // пишем в память 1000
    I_ANOD_MAX = word (EEPROM.read(12), EEPROM.read(13));}                          // читаем новое значение в переменную

    I_ANOD_ROUND = EEPROM.read(14);                                                 // читаем из памяти значение шага округления тока анода
  if ((isnan(I_ANOD_ROUND) == true)||((I_ANOD_ROUND < 1)||(I_ANOD_ROUND > 100))){   // проверяем на нечисло и если шаг округления меньше 1 или больше 100
    EEPROM.update(14,10); I_ANOD_ROUND = EEPROM.read(14);}                          // пишем в память 10 и читаем новое значение в переменную

    U_GRID2_MAX = word (EEPROM.read(16), EEPROM.read(17));                          // читаем из памяти максимальное значение напряжения второй сетки
  if ((isnan(U_GRID2_MAX) == true) || ((U_GRID2_MAX < 50) || (U_GRID2_MAX > 900))){ // проверяем на нечисло и если значение меньше 50 или больше 900
    EEPROM.update(16, highByte(400)); EEPROM.update(17, lowByte(400));              // пишем в память 400
    U_GRID2_MAX = word (EEPROM.read(16), EEPROM.read(17));}                         // читаем новое значение в переменную

    U_GRID2_ROUND = EEPROM.read(18);                                                // читаем из памяти значение шага округления напряжения второй сетки
  if ((isnan(U_GRID2_ROUND) == true)||((U_GRID2_ROUND < 1)||(U_GRID2_ROUND > 20))){ // проверяем на нечисло и если шаг округления меньше 1 или больше 20
    EEPROM.update(18,10); U_GRID2_ROUND = EEPROM.read(18);}                         // пишем в память 10 и читаем новое значение в переменную

    I_GRID_MAX = word (EEPROM.read(20), EEPROM.read(21));                           // читаем из памяти максимальное значение тока сетки мА
  if ((isnan(I_GRID_MAX) == true) || ((I_GRID_MAX < 5) || (I_GRID_MAX > 2000))){    // проверяем на нечисло и если значение меньше 1 или больше 2000
    EEPROM.update(20, highByte(100)); EEPROM.update(21, lowByte(100));              // пишем в память 100
    I_GRID_MAX = word (EEPROM.read(20), EEPROM.read(21));}                          // читаем новое значение в переменную  
    
    I_GRID_ROUND = EEPROM.read(22);                                                 // читаем из памяти значение шага округления тока сетки
  if ((isnan(I_GRID_ROUND) == true)||((I_GRID_ROUND < 1)||(I_GRID_ROUND > 50))){    // проверяем на нечисло и если шаг округления меньше 1 или больше 50
    EEPROM.update(22,5); I_GRID_ROUND = EEPROM.read(22);}                           // пишем в память 5 и читаем новое значение в переменную
    
    TIME_ON = EEPROM.read(24);                                                      // читаем из памяти значение времени включения (нагрева), сек
  if ((isnan(TIME_ON) == true) || ((TIME_ON < 10) || (TIME_ON > 250))){             // проверяем на нечисло и если время меньше 10 или больше 250 секунд 
    EEPROM.update(24,80); TIME_ON = EEPROM.read(24);}                               // пишем в память 80 и читаем новое значение в переменную

    TIME_OFF = EEPROM.read(26);                                                     // читаем из памяти значение времени отключения (охлаждения), сек
  if ((isnan(TIME_OFF) == true) || ((TIME_OFF < 30) || (TIME_OFF > 250))){          // проверяем на нечисло и если время меньше 30 или больше 250 секунд 
    EEPROM.update(26,120); TIME_OFF = EEPROM.read(26);}                             // пишем в память 120 и читаем новое значение в переменную

    TIME_LIGHT = EEPROM.read(28);                                                   // читаем из памяти значение задержки на отключение подсветки ЖКИ (в минутах)
  if ((isnan(TIME_LIGHT) == true) || ((TIME_LIGHT < 1) || (TIME_LIGHT > 250))){     // проверяем на нечисло и если время меньше 1 или больше 250 минут
    EEPROM.update(28,5); TIME_LIGHT = EEPROM.read(28);}                             // пишем в память 5 и читаем новое значение в переменную
    
    TIME_SLEEP = EEPROM.read(30);                                                   // читаем из памяти значение задержки на переход в спящий режим (в минутах)
  if ((isnan(TIME_SLEEP) == true) || ((TIME_SLEEP < 2) || (TIME_SLEEP > 250))){     // проверяем на нечисло и если время меньше 2 или больше 250 минут
    EEPROM.update(30,20); TIME_SLEEP = EEPROM.read(30);}                            // пишем в память 20 и читаем новое значение в переменную

    STEPmax = EEPROM.read(32);                                                      // читаем из памяти значение шага уменьшения градусника
  if ((isnan(STEPmax) == true) || ((STEPmax < 1) || (STEPmax > 250))){              // проверяем на нечисло и если шаг меньше 1 или больше 250
    EEPROM.update(32,10); STEPmax = EEPROM.read(32);}                               // пишем в память 10 и читаем новое значение в переменную

    UPDATE_BAR = EEPROM.read(34);                                                   // читаем из памяти значение времени обновления градусника в мс
  if ((isnan(UPDATE_BAR) == true) || ((UPDATE_BAR < 10) || (UPDATE_BAR > 250))){     // проверяем на нечисло и если время меньше 10 или больше 250 мс
    EEPROM.update(34,50); UPDATE_BAR = EEPROM.read(34);}                            // пишем в память 50 и читаем новое значение в переменную

    SWR_HI = EEPROM.read(36);                                                       // читаем из памяти значение КСВ, выше которого блокируется работа усилителя
  if ((isnan(SWR_HI) == true) || ((SWR_HI < 2) || (SWR_HI > 100))){                 // проверяем на нечисло и если КСВ меньше 2 или больше 100
    EEPROM.update(36,5); SWR_HI = EEPROM.read(36);}                                 // пишем в память 5 и читаем новое значение в переменную

    VOXDelay = EEPROM.read(38);                                                     // читаем из памяти значение задержки отпускания VOX
  if ((isnan(VOXDelay) == true) || ((VOXDelay < 5) || (VOXDelay > 100))){           // проверяем на нечисло и если время меньше 5 или больше 100
    EEPROM.update(38,30); VOXDelay = EEPROM.read(38);}                              // пишем в память 30 и читаем новое значение в переменную

    DELAY_SWITCH = EEPROM.read(40);                                                 // читаем из памяти значение задержки на переключение реле диапазонов, мс
  if ((isnan(DELAY_SWITCH) == true)||((DELAY_SWITCH < 1)||(DELAY_SWITCH > 100))){   // проверяем на нечисло и если время меньше 1 или больше 100
    EEPROM.update(40,50); DELAY_SWITCH = EEPROM.read(40);}                          // пишем в память 50 и читаем новое значение в переменную  

    REFERENCE = EEPROM.read(42);                                                    // читаем из памяти значение опорного напряжения
  if (REFERENCE != 11){EEPROM.update(42,0); REFERENCE = EEPROM.read(42);}           // если значение не равно 11, пишем в память 0 и читаем новое значение
    
    lcd.setCursor(0,0); lcd.leftToRight();                                          // уст. курсор в (0,0), вывод текста слева направо
    dotimes(strlen(text1),{lcd.write(text1[i]); delay(75);})                        // выводим каждый символ текста text1 с задержкой
    lcd.setCursor(0,1); lcd.leftToRight();                                          // уст. курсор в (0,1), вывод текста слева направо
    dotimes(strlen(text2),{lcd.write(text2[i]); delay(75);})                        // выводим каждый символ текста text2 с задержкой
    lcd.setCursor(0,2); lcd.leftToRight();                                          // уст. курсор в (0,2), вывод текста слева направо
    dotimes(strlen(text3),{lcd.write(text3[i]); delay(75);})                        // выводим каждый символ текста text3 с задержкой
    lcd.setCursor(0,3); lcd.leftToRight();                                          // уст. курсор в (0,2), вывод текста слева направо
    dotimes(strlen(text4),{lcd.write(text4[i]); delay(75);})                        // выводим каждый символ текста text4 с задержкой
    delay(2000);                                                                    // задержка вывода заставки 2сек
    startLCD(); set_band();                                                         // запускаем индикацию, выводим диапазон
}
void loop(){//*********************************************************************************************** Основной цикл
    global_timer();                                                                 // вызов таймера общего хода времени

  if (beep.isReady())  digitalWrite (SOUND, LOW);                                   // если таймер бипера готов, отключаем бипер
  if (error.isReady()) digitalWrite (SOUND, LOW);                                   // если таймер аварии готов, отключаем сигнал аварии
  
    startCounting(2);    delay(2);                                                  // старт счета частоты, задержка 2мс
    frq = (timerCounts*0.64) / timerPeriod;                                         // получаем входную частоту

  if ((frq>16)&&(!flag_swr_hi)&&(!flag_Ua)){ valvox=0;                              // если частота выше 1.6МГц, не сработала защита по КСВ, обнуляем задержку VOX
    timer2=0; lcd.backlight();                                                      // сбрасываем второй таймер, включаем подсветку индикатора
  for (byte i=0; i<3; i++){startCounting(2); delay(2);                              // вкл. первый цикл, старт счета, задержка на подсчет 2мс
    frq = (timerCounts*0.64) / timerPeriod;                                         // получаем входную частоту
  if (frq>frq_old1) frq_old1=frq;}                                                  // если частота frq больше промежуточной frq_old1, перезаписываем в frq_old1 значение frq
  for (byte i=0; i<3; i++){startCounting(2); delay(2);                              // вкл. второй цикл, старт счета, задержка на подсчет 2мс
    frq = (timerCounts*0.64) / timerPeriod;                                         // получаем входную частоту
  if (frq>frq_old2) frq_old2=frq;}                                                  // если частота frq больше промежуточной frq_old2, перезаписываем в frq_old2 значение frq
  for (byte i=0; i<3; i++){startCounting(2); delay(2);                              // вкл. третий цикл, старт счета, задержка на подсчет 2мс
    frq = (timerCounts*0.64) / timerPeriod;                                         // получаем входную частоту
  if (frq>frq_old3) frq_old3=frq;}                                                  // если частота frq больше промежуточной frq_old3, перезаписываем в frq_old3 значение frq
  
  if ((frq_old1==frq_old2) && (frq_old2==frq_old3)) frq_get=frq_old1;               // проверяем равенство частот frq_old1=frq_old2=frq_old3
  
  switch (frq_get){                                                                 // 
    case 17  ...  30: band_get=1; break;                                            // получаем диапазон для переключения 160м(1)
    case 31  ...  50: band_get=2; break;                                            // получаем диапазон для переключения 80м (2)
    case 51  ...  80: band_get=3; break;                                            // получаем диапазон для переключения 40м (3)
    case 81  ... 120: band_get=4; break;                                            // получаем диапазон для переключения 30м (4)
    case 121 ... 160: band_get=5; break;                                            // получаем диапазон для переключения 20м (5)
    case 161 ... 190: band_get=6; break;                                            // получаем диапазон для переключения 17м (6)
    case 191 ... 230: band_get=7; break;                                            // получаем диапазон для переключения 15м (7)
    case 231 ... 260: band_get=8; break;                                            // получаем диапазон для переключения 12м (8)
    case 261 ... 300: band_get=9; break;}}                                          // получаем диапазон для переключения 10м (9)
  
  else {frq_old1=0; frq_old2=0; frq_old3=0; frq_get=0;}                             //если частота ниже 1.6МГц, обнуляем промежуточные значения
  
  if (band_get != band){ beep.start(); digitalWrite(SOUND, HIGH);                   // если текущий диапазон не равен новому значению, бипер,
    delay_band=millis();                                                            // принимаем текущее значение времени
    band = band_get;  EEPROM.update(0, band_get);                                   // переписываем новое значение в текущий, обновляем в памяти
    frqbuf = frq_get; EEPROM.update(1, highByte(frqbuf));                           // переписываем новое значение частоты, обновляем в памяти
    EEPROM.update(2, lowByte(frqbuf)); set_band();}                                 // и устанавливаем новый диапазон

  if (millis() - VoxMillis >= 1){VoxMillis = millis(); valvox++;}                   // формируем задержку на выключение, пока счетчик valvox считает
  if (valvox >= VOXDelay){valvox = 0; digitalWrite(TX, LOW);}                       // как только досчитали, переходим на прием

//  if ((power)&&(frq_get>16)&&(millis()-delay_band>DELAY_SWITCH)&&(!bypass))         // если питание подано, частота выше 1.6МГц и задержка больше значения DELAY_SWITCH
//    digitalWrite(TX, HIGH);                                                         // переходим на передачу
  
  if ((power)&&(!bypass)&&(millis()-delay_band>DELAY_SWITCH)&&                      // если питание подано, обход отключен, задержка больше значения DELAY_SWITCH и
    ((frq_get>16)||(digitalRead(PTT_IN)==LOW))) digitalWrite(TX, HIGH);             // частота выше 1.6МГц или есть сигнал внешнего управления (педаль), режим передачи
  
  switch(button1.Loop()){                                                           // кнопка 1
  case SB_CLICK: beep.start(); digitalWrite(SOUND, HIGH); timer2=0; lcd.backlight();// короткое нажатие: бипер 50мс, сбрасываем timer2, включаем подсветку
  if ((flag_swr_hi)&&(!flag_Ua)){flag_swr_hi=0; digitalWrite(SCREEN, HIGH);         // если флаг высокого КСВ равен 1, сбрасываем его в 0, включаем экр. напряжение
    delay(100); break;}                                                             // задержка 100мс, выход из кнопки 1
  if (power) {bypass=!bypass; digitalWrite(TX, LOW); lcd.setCursor(0,0);            // инвертируем флаг обхода, отключаем передачу, курсор в 3,0
  if (bypass) lcd.print("   - BYPASS -   ");                                        // если обход включен, выводим "- BYPASS -"
  else lcd.print("                ");}                                              // если отключен, стираем надпись
  if (!power){if (--band<1) band=9; flag_band=1;}                                   // если питание отключено, диапазон вниз по кольцу, флаг диапазона в 1  
    break;                                                                          // конец функции короткого нажатия
  
  case SB_LONG_CLICK: beep.start(); digitalWrite(SOUND, HIGH); power=!power;        // длинное нажатие: бипер, переворачиваем флаг питания
    flag_cool=!flag_cool; bypass=0;                                                 // взводим таймер счета, отключаем обход усилителя
    flag_swr_hi=0; flag_Ua=0; sec=0; minut=0; timer2=0; lcd.clear(); CharClock();   // обнуляем флаг высокого КСВ, обнуляем секунды и минуты, загружаем символы в индикатор
    lcd.setCursor(9,1); lcd.write(165); lcd.setCursor(9,2); lcd.write(165);         // выводим двоеточие между цифрами
  if (power)  heating();                                                            // если флаг питания 1, уходим на нагрев
  if (!power) cooling();                                                            // если флаг питания 0, уходим на охлаждение
    break;}                                                                         // конец функции кнопки 1

  switch(button2.Loop()){                                                           // кнопка 2
  case SB_CLICK: beep.start(); digitalWrite(SOUND, HIGH); timer2=0; lcd.backlight();// короткое нажатие, бипер, взводим таймер подсветки, вкл. подсветку
  if (++band>9) band=1; flag_band=1; break;                                         // переключаем диапазон вверх, флаг переключения диапазонов в 1
  
  case SB_LONG_CLICK: beep.start(); digitalWrite(SOUND, HIGH); timer2=0;            // длинное нажатие, бипер, взводим таймер подсветки
    lcd.backlight(); menu(); break;}                                                // вкл. подсветку, вызов меню
  
  if (flag_band){ flag_band=0;                                                      // флаг ручного переключения диапазонов, сбрасываем флаг в 0
    band_get=band; EEPROM.update(0, band_get);                                      // пишем номер диапазона в память
  switch(band){                                                                     // по номеру диапазона
    case 1: frqbuf=19;   break;                                                     // выбираем частоту 1.9МГц
    case 2: frqbuf=36;   break;                                                     // выбираем частоту 3.6МГц
    case 3: frqbuf=71;   break;                                                     // выбираем частоту 7.1МГц
    case 4: frqbuf=101;  break;                                                     // выбираем частоту 10.1МГц
    case 5: frqbuf=141;  break;                                                     // выбираем частоту 14.1МГц
    case 6: frqbuf=181;  break;                                                     // выбираем частоту 18.1МГц
    case 7: frqbuf=212;  break;                                                     // выбираем частоту 21.2МГц
    case 8: frqbuf=249;  break;                                                     // выбираем частоту 24.9МГц
    case 9: frqbuf=285;  break;}                                                    // выбираем частоту 28.5МГц
    EEPROM.update(1, highByte (frqbuf));                                            // пишем в память старший байт
    EEPROM.update(2, lowByte  (frqbuf)); set_band();}                               // пишем в память младший байт, выводим частоту и диапазон
//************************************************************************************ Управление подсветкой и переход в Bypass по времени  
  if (ReadUfor>10) {timer2=0; lcd.backlight();}                                     // если есть выходной сигнал, обнуляем таймер2, включаем подсветку ЖКИ
  else {                                                                            // если сигнал отсутствует
  if (TIME_LIGHT==timer2) lcd.noBacklight();                                        // при достижении времени до TIME_LIGHT отключаем подсветку
  if ((TIME_SLEEP-1==timer2)&&(sec==45)&&(power)){                                  // за 15 секунд до сна и вкл. питании
    error.start(); digitalWrite(SOUND, HIGH);}                                      // предупредительный сигнал
  if ((TIME_SLEEP==timer2)&&(flag_cool)){power=!power; sec=0; minut=0; lcd.clear(); // при достижении времени до TIME_SLEEP переворачиваем флаг питания, обнуляем секунды и минуты, стираем ЖКИ
    CharClock(); lcd.setCursor(9,1); lcd.write(165); lcd.setCursor(9,2);            // загружаем сегменты цифр в ОЗУ индикатора, выводим двоеточие
    lcd.write(165); cooling(); flag_cool=0;}}                                       // уходим на охлаждение, обнуляем флаг охлаждения
  if (power){                                                                       // если флаг питания включен
//************************************************************************************ Градусник прямой волны  
  if (ReadUfor>Upk) Upk=ReadUfor;                                                   // если уровень с порта больше пикового значения, выравниваем показания
    STEP=map(ReadUfor,0,Upk,STEPmax,0);                                             // вычисляем шаг уменьшения градусника
  if (Upk){                                                                         // если есть напряжение прямой волны
  if (Upk<STEP) Upk=0;                                                              // если остаточное напряжение меньше шага уменьшения градусника, обнуляем значение
  else Upk-=STEP;}                                                                  // иначе уменьшаем "высоту градусника" на один шаг

    byte a=Upk/63;                                                                  // вычисляем целое число a для градусника
    byte b=Upk-a*63;                                                                // вычисляем значение переменной b остатка от деления
  if (!bypass){                                                                     // если режим обхода отключен      
      lcd.setCursor(0,0);                                                           // уст. курсор начала градусника
  for (byte i=0; i<a; i++) lcd.write(3);                                            // выводим целую часть, если она больше 0
  switch(b){                                                                        // выводим дробную часть градусника
    case 1  ... 21: lcd.write(1);  break;                                           // если b=1...17
    case 22 ... 42: lcd.write(2);  break;                                           // если b=18...34
    case 43 ... 63: lcd.write(3);  break;}                                          // если b=35...51
  if (a<15) lcd.write(32);}                                                         // в конце пробел, если a<15
//************************************************************************************ Расчет КСВ
  if (!Upk) SWR=1.0;                                                                // в отсутствии сигнала КСВ=1
  if (ReadUfor && ReadUrev && ReadUrev >= ReadUfor) SWR=99;                         // если напряжение пр. и обр. волны равны или обр. больше прямой, то КСВ максимальное
  if (ReadUfor>ReadUrev){SWR=(float)(ReadUfor+ReadUrev)/(float)(ReadUfor-ReadUrev);}// если ReadUfor>ReadUrev, то выводим значение КСВ, расчитанное по формуле
  if (SWR>99) SWR=99;                                                               // ограничиваем КСВ до значения 99
  if (SWR>=SWRpk) {SWRpk=SWR; SWRcount=0;}                                          // фиксируем пиковое/максимальное значение КСВ
  if (SWR>5.0) {error.start(); digitalWrite(SOUND, HIGH);}                          // при КСВ выше 5.0 подаем сигнал на порт SOUND
  if (SWR>SWR_HI) flag_swr_hi=1;                                                    // если КСВ больше SWR_HI, то флаг высокого КСВ уст. в 1
     lcd.setCursor(15,1);                                                           // курсор в позицию 15,1
  if (flag_swr_hi) lcd.print("HIGH ");                                              // если флаг высокого КСВ равен 1, выводим "HIGH"
  else  {                                                                           // если равен 0
    if (!Upk) lcd.print("WAIT ");                                                   // в отсутствии сигнала прямой волны выводим "WAIT"
    else {                                                                          // в наличии сигнала прямой волны
      if (++SWRcount<50){lcd.print(SWRpk,1); lcd.print(" ");}                       // выводим значение КСВ до десятых с задержкой, пока счетчик меньше 50
      else SWRpk=SWR;}}                                                             // если счетчик больше 50, обновляем пиковое значение КСВ
//************************************************************************************ Расчёт мощности
    Vf  =(float)(Upk*k/201.58);                                                     // вычисляем напряжение на нагрузке
    PWR =(float)(Vf*Vf)/50;                                                         // вычисляем мощность

uint16_t PWR_rnd=PWR/PWRStep; PWR=PWR_rnd*PWRStep;                                  // округляем мощность кратно PWRStep
  if (PWR>=PWRpk) {PWRpk=PWR; PWRcount=0;}                                          // фиксируем пиковое значение PWRpk, обнуляем счетчик
  if (++PWRcount<50){                                                               // если счетчик меньше 50
      lcd.setCursor(4,1); lcd.print(PWRpk);                                         // выводим значение мощности
  if (PWRpk<100) lcd.print("W   ");                                                 // дописываем "W   " в конце, если мощность меньше 10000Вт
  else lcd.print("W ");}                                                            // иначе дописываем "W " в конце
  else PWRpk=PWR;                                                                   // иначе обновляем новое значение PWRpk
//************************************************************************************ Расчёт и вывод напряжения анода
      Ua=map(ReadUa,0,1023,0,U_ANOD_MAX+U_ANOD_ROUND-1);                            // масштабируем показания напряжения анода
uint16_t Ua_rnd=Ua/U_ANOD_ROUND; Ua=Ua_rnd*U_ANOD_ROUND;                            // округляем показания напряжения анода
  if ((Ua<(2*Ugrid2))&&(!flag_Ua)){flag_Ua=1;                                       // если напр. анода ниже удвоенного экранного и флаг пропадания анодн. напряжения 0, флаг уст. в 1
      digitalWrite(SCREEN,LOW); digitalWrite(ANOD,LOW);                             // отключаем экранное и анодное напряжения
      error.start(); digitalWrite(SOUND, HIGH);}                                    // сигнал аварии    
      lcd.setCursor(3,2);                                                           // курсор в позицию 3,2
  if (flag_Ua) {lcd.setCursor(3,2); lcd.print("ERROR ");}                           // если сработал флаг пропадания анодного напряжения, выводим ERROR
  else {lcd.print(Ua); lcd.print("V   ");}                                          // иначе выводим на экран значение напряжения, добавляем в конце "V"
//************************************************************************************ Расчёт и вывод напряжения второй сетки
      Ugrid2=map(ReadUgrid2,0,1023,0,U_GRID2_MAX+U_GRID2_ROUND-1);                  // масштабируем показания напряжения второй сетки
uint16_t Ugrid2_rnd=Ugrid2/U_GRID2_ROUND;                                           // округляем показания напряжения анода
         Ugrid2=Ugrid2_rnd*U_GRID2_ROUND;                                           // получаем новое значение
      lcd.setCursor(3,3);                                                           // курсор в позицию 3,3
  if ((flag_swr_hi)||(flag_Ua)) lcd.print("OFF   ");                                // если флаг высокого КСВ равен 1, выводим "OFF"
  else {lcd.print(Ugrid2); lcd.print("V   ");}                                      // иначе выводим на экран напряжение, добавляем в конце "V"
//************************************************************************************ Расчёт и вывод тока анода
      Ia=map(ReadIa,0,1000,0,I_ANOD_MAX+I_ANOD_ROUND-1);                            // масштабируем показания тока анода
    if (I_ANOD_ROUND>1){uint16_t Ia_rnd=Ia/I_ANOD_ROUND;                            // округляем показания тока анода, если шаг округления больше 1
      Ia=Ia_rnd*I_ANOD_ROUND;}                                                      // ------------------------
      lcd.setCursor(14,2); lcd.print(Ia);                                           // выводим значение тока анода на экран
  switch(Ia){  
    case 0   ...   9: lcd.print("mA   "); break;                                    // если показания 0 ... 9, дописываем "mA   " в конце
    case 10  ...  99: lcd.print("mA  ");  break;                                    // если показания 10 ... 99, дописываем "mA  " в конце
    case 100 ... 999: lcd.print("mA ");   break;                                    // если показания 100 ... 999, дописываем "mA " в конце
    default         : lcd.print("mA");    break;}                                   // если показания больше 1000, дописываем "mA" в конце
//************************************************************************************ Расчёт и вывод тока второй сетки
      Igrid=map(ReadIgrid,0,1000,0,I_GRID_MAX+I_GRID_ROUND-1);                      // масштабируем показания тока сетки
     if (I_GRID_ROUND>1){uint16_t Ig_rnd=Igrid/I_GRID_ROUND;                        // округляем показания тока сетки, если шаг округления больше 1
      Igrid=Ig_rnd*I_GRID_ROUND;}                                                   // ------------------------
      lcd.setCursor(14,3); lcd.print(Igrid);                                        // выводим значение тока сетки на экран
  switch(Igrid){  
    case 0   ...   9: lcd.print("mA   "); break;                                    // если показания 0 ... 9, дописываем "mA   " в конце
    case 10  ...  99: lcd.print("mA  ");  break;                                    // если показания 10 ... 99, дописываем "mA  " в конце
    case 100 ... 999: lcd.print("mA ");   break;                                    // если показания 100 ... 999, дописываем "mA " в конце
    default         : lcd.print("mA");    break;}                                   // если показания больше 1000, дописываем "mA" в конце  
    
    if (!bypass){lcd.setCursor(4,0);                                                // если обход отключен, в позиции курсора 4,0
    if (Upk<=10){flag_time=0;                                                       // если пиковое напряжение пр. волны меньше 10, флаг времени в 0
    if (chas<10){lcd.print("0"); lcd.print(chas);}                                  // выводим часы, если значение меньше 10
    else lcd.print(chas);                                                           // если значение больше 10
      lcd.print(":");                                                               // добавляем двоеточие
    if (minut<10){lcd.print("0"); lcd.print(minut);}                                // выводим минуты, если значение меньше 10
    else lcd.print(minut);                                                          // если значение больше 10
      lcd.print(":");                                                               // добавляем двоеточие
    if (sec<10){lcd.print("0"); lcd.print(sec);}                                    // выводим секунды, если значение меньше 10
    else lcd.print(sec); lcd.print(" ");}                                           // если значение больше 10
    if ((Upk>10)&&(!flag_time)){flag_time=1;                                        // если пиковое напряжение пр. волны больше 10 и флаг времени 0, флаг времени в 1
      lcd.print("        ");}}                                                      // и затираем время пробелами
}}
//************************************************************************************ Подпрограмма сегментов градусника
void CharBar() {                                                                    // заносим сегменты градусника в память ОЗУ индикатора
    lcd.createChar(1,symbol1);                                                      // загружаем символ из массива symbol1 в 1 ячейку ОЗУ дисплея
    lcd.createChar(2,symbol2);                                                      // загружаем символ из массива symbol2 во 2 ячейку ОЗУ дисплея 
    lcd.createChar(3,symbol3);                                                      // загружаем символ из массива symbol3 в 3 ячейку ОЗУ дисплея
}
//************************************************************************************ Подпрограмма сегментов цифр
void CharClock() {                                                                  // заносим сегменты в память ОЗУ индикатора
    lcd.createChar(0, LT);                                                          // -------------------------
    lcd.createChar(1, UB);                                                          // -------------------------
    lcd.createChar(2, RT);                                                          // -------------------------
    lcd.createChar(3, LL);                                                          // -------------------------
    lcd.createChar(4, LB);                                                          // -------------------------
    lcd.createChar(5, LR);                                                          // -------------------------
    lcd.createChar(6, UMB);                                                         // -------------------------
    lcd.createChar(7, LMB);}                                                        // -------------------------
//************************************************************************************ Подпрограмма вывода минут
void drawMin(byte minutes, byte x, byte y) {                                        // 
    drawDig(minutes/10,x,y);                                                        // 
    drawDig(minutes%10,x+3,y);}                                                     // 
//************************************************************************************ Подпрограмма вывода часов
void drawSec(byte seconds, byte x, byte y) {                                        // 
    drawDig(seconds/10,x+7,y);                                                      // 
    drawDig(seconds%10,x+10,y);}                                                    // 
//************************************************************************************ Подпрограмма вывода сегментов цифр
void drawDig(byte dig, byte x, byte y) {                                            // 
  switch (dig) {                                                                    // 
    case 0:                                                                         // цифра "0"
      lcd.setCursor(x, y); lcd.write(0); lcd.write(1); lcd.write(2);                // 
      lcd.setCursor(x, y + 1); lcd.write(3); lcd.write(4); lcd.write(5); break;     // 
    case 1:                                                                         // цифра "1"
      lcd.setCursor(x, y); lcd.write(32); lcd.write(1); lcd.write(2);               // 
      lcd.setCursor(x, y + 1); lcd.write(32); lcd.write(32); lcd.write(5); break;   // 
    case 2:                                                                         // цифра "2"
      lcd.setCursor(x, y); lcd.write(6); lcd.write(6); lcd.write(2);                // 
      lcd.setCursor(x, y + 1); lcd.write(3); lcd.write(7); lcd.write(7); break;     // 
    case 3:                                                                         // цифра "3"
      lcd.setCursor(x, y); lcd.write(6);lcd.write(6);lcd.write(2);                  // 
      lcd.setCursor(x, y + 1); lcd.write(7); lcd.write(7); lcd.write(5); break;     // 
    case 4:                                                                         // цифра "4"
      lcd.setCursor(x, y); lcd.write(3); lcd.write(4); lcd.write(2);                // 
      lcd.setCursor(x, y + 1); lcd.write(32); lcd.write(32);lcd.write(5); break;    // 
    case 5:                                                                         // цифра "5"
      lcd.setCursor(x, y); lcd.write(0); lcd.write(6); lcd.write(6);                // 
      lcd.setCursor(x, y + 1); lcd.write(7); lcd.write(7); lcd.write(5); break;     // 
    case 6:                                                                         // цифра "6"
      lcd.setCursor(x, y); lcd.write(0); lcd.write(6); lcd.write(6);                // 
      lcd.setCursor(x, y + 1); lcd.write(3); lcd.write(7); lcd.write(5); break;     // 
    case 7:                                                                         // цифра "7"
      lcd.setCursor(x, y); lcd.write(1); lcd.write(1); lcd.write(2);                // 
      lcd.setCursor(x, y + 1); lcd.write(32); lcd.write(0); lcd.write(32); break;   // 
    case 8:                                                                         // цифра "8"
      lcd.setCursor(x, y); lcd.write(0); lcd.write(6); lcd.write(2);                // 
      lcd.setCursor(x, y + 1); lcd.write(3); lcd.write(7); lcd.write(5); break;     // 
    case 9:                                                                         // цифра "9"
      lcd.setCursor(x, y); lcd.write(0); lcd.write(6); lcd.write(2);                // 
      lcd.setCursor(x, y + 1); lcd.write(7); lcd.write(7); lcd.write(5); break;}}   // 
//************************************************************************************ Настройка АЦП
void ADC_init(){                                                                    // Подпрограмма настройки АЦП
    ADCSRA = 0; ADCSRB = 0;                                                         // Сбрасываем регистры ADCSRA и ADCSRB
    REFERENCE = EEPROM.read(42);                                                    // Читаем значение опорного напряжения из памяти
  if (REFERENCE == 11){ADMUX |= (1<<REFS0)|(1<<REFS1);}                             // Если значение равно 11, опорное напряжение 1.1В
  else {ADMUX |= (1<<REFS0);}                                                       // иначе опорное напряжение 5В
    analog_ref = ADMUX;                                                             // Запоминаем состояние регистра - из него мы будем формировать маску для смены входного пина
    ADMUX |= (0 & 0x07);                                                            // Выбираем начальный пин A0 для преобразования
                                                                                    // Устанавливаем предделитель - [111-128] [110-64] [101-32] [100-16] [011-8]
 ADCSRA |=(1<<ADEN)|(1<<ADATE)|(1<<ADIE)|(1<<ADSC)|(1<<ADPS2)|(0<<ADPS1)|(1<<ADPS0);// Вкл. АЦП, авт. преобразование, прерывание по завершении преобразования, преобразование, предделитель
}
//************************************************************************************ Работа АЦП по прерыванию
ISR(ADC_vect) {                                                                     // 
  if (trueValue) {                                                                  // если флаг смены входного пина АЦП
    int result = ADCL | (ADCH << 8);                                                // Получаем 10-битный результат
switch(analogPin){
  case A0: ReadUa=result; break;                                                    // Входной пин A0, получаем значение анодного напряжения
  case A1: ReadIa = result; if (ReadIa>=1000) ReadIa=1000; break;                   // Входной пин A1, получаем значение тока анода, ограничиваем до 1000
  case A2: ReadUgrid2  = result; break;                                             // Входной пин A2, получаем значение напряжения второй сетки
  case A3: ReadIgrid = result; if (ReadIgrid>=1000) ReadIgrid=1000;                 // Входной пин A3, получаем значение тока сетки, ограничиваем до 1000
    if (ReadIgrid<10) ReadIgrid=0; break;                                           // Отсекаем "шум" значения АЦП ниже 10
  case A4: break;                                                                   // Пропускаем
  case A5: break;                                                                   // Пропускаем
  case A6: ReadUfor = result; if (ReadUfor>=1008) ReadUfor=1008;                    // Входной пин A6, получаем значение напряжения прямой волны, ограничение до 1008
    if (ReadUfor<10) ReadUfor=0; break;                                             // Отсекаем "шум" значения АЦП ниже 10
  case A7: ReadUrev   = result;  if (ReadUrev>=1008) ReadUrev=1008;                 // Входной пин A7, получаем значение напряжения обратной волны, ограничение до 1008
    if (ReadUrev<10) ReadUrev=0; break;}                                            // Отсекаем "шум" значения АЦП ниже 10
      analogPin++;                                                                  // Перебираем входные пины по кругу (А0...А7)
  if (analogPin == A4) analogPin = A6;                                              // Пропускаем А4 и А5
  if (analogPin >  A7) analogPin = A0;                                              // После А7 переходим к А0
    int pin = analogPin;                                                            // Приводим пин вида A0 (14) к удобному для регистра ADMUX - 0. A0=14, A1=15, ...
  if (pin >= 14) pin -= 14;                                                         // Переходим к пину А0
    ADMUX = analog_ref | (pin & 0x07);                                              // Устанавливаем новый вход для преобразования
    trueValue = false;}                                                             // Устанавливаем флаг смены входного пина - следующее прерывание пропускаем
  else trueValue = true;                                                            // Первый раз пропускаем считывание и устанавливаем флаг на чтение в следующий раз
}
//************************************************************************************ Старт индикатора
void startLCD(){
    lcd.clear();                                                                    // очищаем дисплей
    k= sqrt((double)PWRMax*50)/5;                                                   // вычисляем коэф. мощности
  if (power){                                                                       // если питание включено
    CharBar();                                                                      // загружаем сегменты градусника в ОЗУ индикатора
    lcd.setCursor(0,1);   lcd.print("PWR=");                                        // выводим на индикатор информацию
    lcd.setCursor(11,1);  lcd.print("SWR=");                                        // -------------------------------
    lcd.setCursor(0,2);   lcd.print("Ua=");                                         // -------------------------------
    lcd.setCursor(11,2);  lcd.print("Ia=");                                         // -------------------------------
    lcd.setCursor(0,3);   lcd.print("Ug=");                                         // -------------------------------
    lcd.setCursor(11,3);  lcd.print("Ig=");}                                        // -------------------------------
  else {                                                                            // если питание отключено
    lcd.setCursor(4,1); lcd.print("Standby ...");                                   // выводим "Standby ..."
    lcd.setCursor(0,2); lcd.print("s1-Band Dn S1-Pwr On");                          // выводим "s1-Bnd Up S1-PowerOn"
    lcd.setCursor(0,3); lcd.print("s2-Band Up S2-Menu");}                           // выводим "s2-Bnd Up S2-Menu"
}
//************************************************************************************ Подпрограмма режима нагрева
void heating(){
    timer=TIME_ON; m=timer/60; s=timer-m*60; lcd.backlight();                       // взводим таймер timer, вычисляем минуты и секунды, включаем подсветку
    lcd.setCursor(4,0); lcd.print("HEATING ...");                                   // выводим "HEATING ..."
  while (timer!=0){global_timer(); drawSec(s,3,1); drawMin(m,3,1);                  // цикл включения, пока счетчик timer не равен нулю
  if ((TIME_ON-timer)==2) {digitalWrite(FAN,   HIGH);                               // на второй секунде счета включаем вентилятор охлаждения
    lcd.setCursor(4,3); lcd.print("Start  FAN");}                                   // выводим "Start FAN"
  if ((TIME_ON-timer)==4) {digitalWrite(GLOW,  HIGH);                               // на четвертой секунде счета включаем накал
    lcd.setCursor(4,3); lcd.print("Start  GLOW");}                                  // выводим "Start GLOW"
  if ((TIME_ON-timer)==TIME_ON-4) {digitalWrite(ANOD,    HIGH);                     // за четыре секунды до конца счета включаем анодное напряжение
    lcd.setCursor(4,3); lcd.print("Start  ANOD");}                                  // выводим "Start ANOD"
  if ((TIME_ON-timer)==TIME_ON-2) {                                                 // за две секунды до конца счета включаем экранное напряжение
    Ua=map(ReadUa,0,1023,0,U_ANOD_MAX);                                             // получаем анодное напряжение
  if (Ua<2*U_GRID2_MAX){digitalWrite(ANOD, LOW); flag_Ua=1;                         // если анодное напряжение ниже удвоенного экранного, откл. анодное напряжение, уст. флаг в 1
    lcd.setCursor(4,3); lcd.print("ANOD  ERROR"); delay(1000); break;}              // выводим "ANOD  ERROR" и прерываем цикл нагрева
  else {                                                                            // если напряжение в норме
    digitalWrite(SCREEN,  HIGH);                                                    // подаем экранное напряжение
    lcd.setCursor(4,3); lcd.print("Start SCREEN");}}                                // выводим "Start SCREEN"
  if (beep.isReady())  digitalWrite (SOUND, LOW);}                                  // 
  if (flag_Ua) {error.start(); digitalWrite(SOUND, HIGH);}                          // если сработал флаг исчезновения анодного напряжения, даем сигнал аварии
  else {beep.start(); digitalWrite(SOUND, HIGH);}                                   // если флаг исчезновения анодного напряжения не сработал, то даем длинный сигнал готовности
    startLCD(); set_band();}                                                        // запускаем рабочий экран индикатора

//************************************************************************************ Подпрограмма режима охлаждения
void cooling(){
    timer=TIME_OFF; m=timer/60; s=timer-m*60;                                       // взводим таймер timer, вычисляем минуты и секунды
    lcd.setCursor(4,0); lcd.print("COOLING ...");                                   // выводим "COOLING ..."
  while (timer!=0){global_timer(); drawSec(s,3,1); drawMin(m,3,1);                  // цикл отключения, пока счетчик timer не равен нулю
  if ((TIME_OFF-timer)==2) {digitalWrite(SCREEN, LOW);                              // на второй секунде отключаем экранное напряжение
    lcd.setCursor(4,3); lcd.print("Stop SCREEN");}                                  // выводим "Stop SCREEN"
  if ((TIME_OFF-timer)==4) {digitalWrite(ANOD,   LOW);                              // на четвертой секунде отключаем анодное напряжение
    lcd.setCursor(4,3); lcd.print("Stop  ANOD ");}                                  // выводим "Stop  ANOD "
  if ((TIME_OFF-timer)==6) {digitalWrite(GLOW,   LOW);                              // на шестой секунде отключаем накал
    lcd.setCursor(4,3); lcd.print("Stop  GLOW");}                                   // выводим "Stop  GLOW"
  if ((TIME_OFF-timer)==TIME_OFF-2) {digitalWrite(FAN, LOW);                        // за две секунды до конца счета отключаем вентилятор охлаждения
    lcd.setCursor(4,3); lcd.print("Stop  FAN ");}                                   // выводим "Stop  FAN "
  if (beep.isReady())  digitalWrite (SOUND, LOW);}                                  // если таймер beep закончил счет, отключаем бипер
    beep.start(); digitalWrite(SOUND, HIGH);                                        // бипер
    startLCD(); set_band();                                                         // запускаем индикацию, выводим диапазон
    lcd.noBacklight();}                                                             // отключаем подсветку
//************************************************************************************ Общий таймер хода часов
void global_timer(){                                                                // 
    new_sec =(millis()/1000)%60;                                                    // таймер 1 секунда
  if (new_sec!=old_sec){old_sec=new_sec; //flagS=1;                                   // с каждой новой секундой флаг секунд в 1
  if (++sec>59) {sec=0; minut++; timer2++;}                                         // считаем секунды, при переполнении увел. минуты и таймер 2
  if (minut>59) {minut=0; chas++;}                                                  // при переполнении минут увел. часы
  if (chas>23)  {chas=0;}                                                           // при переполнении часов сбрасываем их в 0
  if (timer>0)  {timer--; s--;                                                      // если таймер обратного хода больше 0, уменьшаем секунды
  if (s<0) {s=59; m--;}}}                                                           // при обратном переполнении секунд уст. на 59, уменьшаем минуты
}
//************************************************************************************ Выбор диапазона
void set_band(){
  if (power)  lcd.setCursor(16,0);                                                  // если питание подано курсор в позицию 16,0
  if (!power){lcd.setCursor(2,0);   lcd.print("FRQ=");                              // если питание отключено (байпас), выводим надпись "FRQ="
    lcd.print((float)frqbuf/10,1);  lcd.print("MHz  ");}                            // и значение частоты формата ХХ.ХМГц
  switch (band){                                                                    // переключаем диапазоны и выводим
    case 1: lcd.print("160m");                                                      // ----------------- 160m -------------------
      digitalWrite(D0, HIGH); digitalWrite(D1, LOW);                                // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, LOW);  digitalWrite(D3, LOW);  break;                        // --------- D3=0--D2=0--D1=0--D0=1 ---------
    case 2: lcd.print("80m ");                                                      // ------------------ 80m -------------------
      digitalWrite(D0, LOW); digitalWrite(D1, HIGH);                                // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, LOW); digitalWrite(D3, LOW);  break;                         // --------- D3=0--D2=0--D1=1--D0=0 ---------
    case 3: lcd.print("40m ");                                                      // ------------------ 40m -------------------
      digitalWrite(D0, HIGH); digitalWrite(D1,HIGH);                                // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, LOW);  digitalWrite(D3,LOW);  break;                         // --------- D3=0--D2=0--D1=1--D0=1 ---------
    case 4: lcd.print("30m ");                                                      // ------------------ 30m -------------------
      digitalWrite(D0, LOW);  digitalWrite(D1, LOW);                                // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, HIGH); digitalWrite(D3, LOW); break;                         // --------- D3=0--D2=1--D1=0--D0=0 ---------
    case 5: lcd.print("20m ");                                                      // ------------------ 20m -------------------
      digitalWrite(D0, HIGH); digitalWrite(D1, LOW);                                // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, HIGH); digitalWrite(D3, LOW); break;                         // --------- D3=0--D2=1--D1=0--D0=1 ---------
    case 6: lcd.print("17m ");                                                      // ------------------ 17m -------------------
      digitalWrite(D0, LOW);  digitalWrite(D1, HIGH);                               // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, HIGH); digitalWrite(D3, LOW); break;                         // --------- D3=0--D2=1--D1=1--D0=0 --------- 
    case 7: lcd.print("15m ");                                                      // ------------------ 15m -------------------
      digitalWrite(D0, HIGH); digitalWrite(D1, HIGH);                               // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, HIGH); digitalWrite(D3, LOW); break;                         // --------- D3=0--D2=1--D1=1--D0=1 --------- 
    case 8: lcd.print("12m ");                                                      // ------------------ 12m -------------------
      digitalWrite(D0, LOW); digitalWrite(D1, LOW);                                 // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, LOW); digitalWrite(D3, HIGH); break;                         // --------- D3=1--D2=0--D1=0--D0=0 --------- 
    case 9: lcd.print("10m ");                                                      // ------------------ 10m -------------------
      digitalWrite(D0, HIGH); digitalWrite(D1, LOW);                                // вывод кода для дешифратора диапазонных ФНЧ
      digitalWrite(D2, LOW);  digitalWrite(D3, HIGH); break;}                       // --------- D3=1--D2=0--D1=0--D0=1 ---------
}
//************************************************************************************ Меню настроек
void menu(){
    int8_t    position=0;                                                           // переменная позиции пункта меню
    uint8_t   step;                                                                 // переменная шага настройки значений
    uint16_t  Select = PWRMax;                                                      // переменная параметров пунктов меню
    bool      flag_position=1;                                                      // флаг позиции

    const char*view[20]={ "1.PWRMax=", "2.PWRStep=", "3.U_ANOD_MAX=",               // пункты меню, символьный массив
                          "4.U_ANOD_ROUND=","5.I_ANOD_MAX=",    "6.I_ANOD_ROUND=",  // 
                          "7.U_GRID2_MAX=", "8.U_GRID2_ROUND=",                     // 
                          "9.I_GRID_MAX=",  "10.I_GRID_ROUND=", "11.TIME_ON=",      // 
                          "12.TIME_OFF=",   "13.TIME_LIGHT=",   "14.TIME_SLEEP=",   // 
                          "15.STEP_MAX=",   "16.UPDATE_BAR=",   "17.SWR_HI=",       // 
                          "18.VOXDelay=",   "19.DEL_SWITCH=",   "20.REFERENCE="};   // 
    
    lcd.clear();                                                                    // очищаем дисплей
    lcd.setCursor(6,0); lcd.print("- MENU -");                                      // курсор в позицию 5,0, выводим "- MENU -"

  while (position>-1 && position<20){                                               // цикл выбора и измения параметров меню
    global_timer();                                                                 // вызов таймера общего хода времени
  if (beep.isReady())  digitalWrite (SOUND, LOW);                                   // отключение таймера бипера

switch(button1.Loop()){                                                             // кнопка 1
  case SB_CLICK: Select-=step; break;                                               // короткое нажатие, уменьшаем значение на один шаг
  case SB_LONG_CLICK: position--; beep.start(); digitalWrite(SOUND, HIGH);          // длинное нажатие, переходим на позицию вниз, если не 0, сигнал предупреждения
    lcd.setCursor(0,2); lcd.print("                    "); flag_position=1; break;} // стираем предыдущий пункт меню, флаг позиции в 1

switch(button2.Loop()){                                                             // кнопка 2
  case SB_CLICK: Select+=step; break;                                               // короткое нажатие, увеличиваем значение на один шаг
  case SB_LONG_CLICK: position++; beep.start(); digitalWrite(SOUND, HIGH);          // переходим на позицию вверх, бипер
    lcd.setCursor(0,2); lcd.print("                    "); flag_position=1; break;} // стираем предыдущий пункт меню, флаг позиции в 1

  if (flag_position){flag_position=0;                                               // если флаг позиции выбран, сбрасываем в 0
  switch(position){                                                                 // 
    case 0:   Select = PWRMax;        step = 100; break;                            // по номеру позиции выбираем параметр и шаг настройки
    case 1:   Select = PWRStep;       step = 10;  break;                            // --------------------------
    case 2:   Select = U_ANOD_MAX;    step = 50;  break;                            // --------------------------
    case 3:   Select = U_ANOD_ROUND;  step = 1;   break;                            // --------------------------
    case 4:   Select = I_ANOD_MAX;    step = 10;  break;                            // --------------------------
    case 5:   Select = I_ANOD_ROUND;  step = 1;   break;                            // --------------------------
    case 6:   Select = U_GRID2_MAX;   step = 50;  break;                            // --------------------------
    case 7:   Select = U_GRID2_ROUND; step = 1;   break;                            // --------------------------
    case 8:   Select = I_GRID_MAX;    step = 5;   break;                            // --------------------------
    case 9:   Select = I_GRID_ROUND;  step = 1;   break;                            // --------------------------
    case 10:  Select = TIME_ON;       step = 10;  break;                            // --------------------------
    case 11:  Select = TIME_OFF;      step = 10;  break;                            // --------------------------
    case 12:  Select = TIME_LIGHT;    step = 1;   break;                            // --------------------------
    case 13:  Select = TIME_SLEEP;    step = 1;   break;                            // --------------------------
    case 14:  Select = STEPmax;       step = 1;   break;                            // --------------------------
    case 15:  Select = UPDATE_BAR;    step = 10;  break;                            // --------------------------
    case 16:  Select = SWR_HI;        step = 1;   break;                            // --------------------------
    case 17:  Select = VOXDelay;      step = 5;   break;                            // --------------------------
    case 18:  Select = DELAY_SWITCH;  step = 10;  break;                            // --------------------------
    case 19:  Select = REFERENCE;     step = 11;  break;}}                          // --------------------------
      
      lcd.setCursor(0,2);                                                           // курсор в позиции 0,2
  
  if (position==0){                                                                 // позиция 0
  if (PWRMax!=Select) PWRMax=Select;                                                // если новое значение не равно предыдущему, выравниваем показания
  if (PWRMax<100)     Select=100;                                                   // ограничение минимальной мощности 100Вт
  if (PWRMax>=10000)  Select=10000;                                                 // ограничение максимальной мощности 10000Вт
      lcd.print(view[position]); lcd.print(PWRMax); lcd.print("W ");}               // выводим номер позиции и его значение

  if (position==1){                                                                 // позиция 1
  if (PWRStep!=Select) PWRStep=Select;                                              // если новое значение не равно предыдущему, выравниваем показания
  if (PWRStep<10)  Select=10;                                                       // ограничение минимального шага до 10
  if (PWRStep>100) Select=100;                                                      // ограничение максимального шага до 100
      lcd.print(view[position]); lcd.print(PWRStep); lcd.print(" ");}               // выводим номер позиции и его значение

  if (position==2){                                                                 // позиция 2
  if (U_ANOD_MAX!=Select) U_ANOD_MAX=Select;                                        // если новое значение не равно предыдущему, выравниваем показания
  if (U_ANOD_MAX<100)     Select=100;                                               // ограничение минимального значения напряжения 100В
  if (U_ANOD_MAX>=10000)  Select=10000;                                             // ограничение максимального значения напряжения 10000В
      lcd.print(view[position]); lcd.print(U_ANOD_MAX); lcd.print("V ");}           // выводим номер позиции и его значение
  
  if (position==3){                                                                 // позиция 3
  if (U_ANOD_ROUND!=Select) U_ANOD_ROUND=Select;                                    // если новое значение не равно предыдущему, выравниваем показания
  if (U_ANOD_ROUND<1)   Select=1;                                                   // ограничение минимального шага до 1
  if (U_ANOD_ROUND>100) Select=100;                                                 // ограничение максимального шага до 100
      lcd.print(view[position]); lcd.print(U_ANOD_ROUND); lcd.print(" ");}          // выводим номер позиции и его значение
  
  if (position==4){                                                                 // позиция 4
  if (I_ANOD_MAX!=Select) I_ANOD_MAX=Select;                                        // если новое значение не равно предыдущему, выравниваем показания
  if (I_ANOD_MAX<10)    Select=10;                                                  // ограничение минимального значения тока анода 10мА
  if (I_ANOD_MAX>5000)  Select=5000;                                                // ограничение максимального значения тока анода 5000мА
      lcd.print(view[position]); lcd.print(I_ANOD_MAX); lcd.print("mA ");}          // выводим номер позиции и его значение
  
  if (position==5){                                                                 // позиция 5
  if (I_ANOD_ROUND!=Select) I_ANOD_ROUND=Select;                                    // если новое значение не равно предыдущему, выравниваем показания
  if (I_ANOD_ROUND<1)   Select=1;                                                   // ограничение минимального шага до 1
  if (I_ANOD_ROUND>100) Select=100;                                                 // ограничение максимального шага до 100
      lcd.print(view[position]); lcd.print(I_ANOD_ROUND); lcd.print(" ");}          // выводим номер позиции и его значение
  
  if (position==6){                                                                 // позиция 6
  if (U_GRID2_MAX!=Select) U_GRID2_MAX=Select;                                      // если новое значение не равно предыдущему, выравниваем показания
  if (U_GRID2_MAX<50)  Select=50;                                                   // ограничение минимального значения напряжения второй сетки, 50В
  if (U_GRID2_MAX>900) Select=900;                                                  // ограничение максимального значения напряжения второй сетки, 900В
      lcd.print(view[position]); lcd.print(U_GRID2_MAX); lcd.print("V ");}          // выводим номер позиции и его значение
  
  if (position==7){                                                                 // позиция 7
  if (U_GRID2_ROUND!=Select) U_GRID2_ROUND=Select;                                  // если новое значение не равно предыдущему, выравниваем показания
  if (U_GRID2_ROUND<1)  Select=1;                                                   // ограничение минимального шага до 1
  if (U_GRID2_ROUND>20) Select=20;                                                  // ограничение максимального шага до 20
      lcd.print(view[position]); lcd.print(U_GRID2_ROUND); lcd.print(" ");}         // выводим номер позиции и его значение
  
  if (position==8){                                                                 // позиция 8
  if (I_GRID_MAX!=Select) I_GRID_MAX=Select;                                        // если новое значение не равно предыдущему, выравниваем показания
  if (I_GRID_MAX<5)   Select=5;                                                     // ограничение минимального значения тока сетки 5мА
  if (I_GRID_MAX>2000) Select=2000;                                                 // ограничение максимального значения тока сетки 2000мА
      lcd.print(view[position]); lcd.print(I_GRID_MAX); lcd.print("mA ");}          // выводим номер позиции и его значение
  
  if (position==9){                                                                 // позиция 9
  if (I_GRID_ROUND!=Select) I_GRID_ROUND=Select;                                    // если новое значение не равно предыдущему, выравниваем показания
  if (I_GRID_ROUND<1)  Select=1;                                                    // ограничение минимального шага до 1
  if (I_GRID_ROUND>50) Select=50;                                                   // ограничение максимального шага до 50
      lcd.print(view[position]); lcd.print(I_GRID_ROUND); lcd.print(" ");}          // выводим номер позиции и его значение
  
  if (position==10){                                                                // позиция 10
  if (TIME_ON!=Select) TIME_ON=Select;                                              // если новое значение не равно предыдущему, выравниваем показания
  if (TIME_ON<10)  Select=10;                                                       // ограничение минимального значения времени нагрева до 10 секунд
  if (TIME_ON>250) Select=250;                                                      // ограничение максимального значения времени нагрева до 250 секунд
      lcd.print(view[position]); lcd.print(TIME_ON); lcd.print("sec ");}            // выводим номер позиции и его значение
  
  if (position==11){                                                                // позиция 11
  if (TIME_OFF!=Select) TIME_OFF=Select;                                            // если новое значение не равно предыдущему, выравниваем показания
  if (TIME_OFF<30)  Select=30;                                                      // ограничение минимального значения времени охлаждения до 30 секунд
  if (TIME_OFF>250) Select=250;                                                     // ограничение максимального значения времени охлаждения до 250 секунд
      lcd.print(view[position]); lcd.print(TIME_OFF); lcd.print("sec ");}           // выводим номер позиции и его значение
  
  if (position==12){                                                                // позиция 12
  if (TIME_LIGHT!=Select) TIME_LIGHT=Select;                                        // если новое значение не равно предыдущему, выравниваем показания
  if (TIME_LIGHT<1)   Select=1;                                                     // ограничение минимального значения времени подсветки индикатора до 1 мин
  if (TIME_LIGHT>250) Select=250;                                                   // ограничение максимального значения времени подсветки индикатора до 250 мин
      lcd.print(view[position]); lcd.print(TIME_LIGHT); lcd.print("min ");}         // выводим номер позиции и его значение
  
  if (position==13){                                                                // позиция 13
  if (TIME_SLEEP!=Select) TIME_SLEEP=Select;                                        // если новое значение не равно предыдущему, выравниваем показания
  if (TIME_SLEEP<2)   Select=2;                                                     // ограничение минимального значения времени перехода в спящий режим до 2 мин
  if (TIME_SLEEP>250) Select=250;                                                   // ограничение максимального значения времени перехода в спящий режим до 250 мин
      lcd.print(view[position]); lcd.print(TIME_SLEEP); lcd.print("min ");}         // выводим номер позиции и его значение
  
  if (position==14){                                                                // позиция 14
  if (STEPmax!=Select) STEPmax=Select;                                              // если новое значение не равно предыдущему, выравниваем показания
  if (STEPmax<1)   Select=1;                                                        // ограничение минимального значения шага сдвига градусника до 1
  if (STEPmax>250) Select=250;                                                      // ограничение максимального значения шага сдвига градусника до 250
      lcd.print(view[position]); lcd.print(STEPmax); lcd.print(" ");}               // выводим номер позиции и его значение
  
  if (position==15){                                                                // позиция 15
  if (UPDATE_BAR!=Select) UPDATE_BAR=Select;                                        // если новое значение не равно предыдущему, выравниваем показания
  if (UPDATE_BAR<10)  Select=10;                                                    // ограничение минимального значения времени обновления градусника до 10мс
  if (UPDATE_BAR>250) Select=250;                                                   // ограничение максимального значения времени обновления градусника до 250мс
      lcd.print(view[position]); lcd.print(UPDATE_BAR); lcd.print("ms ");}          // выводим номер позиции и его значение
  
  if (position==16){                                                                // позиция 16
  if (SWR_HI!=Select) SWR_HI=Select;                                                // если новое значение не равно предыдущему, выравниваем показания
  if (SWR_HI<2)   Select=2;                                                         // ограничение минимального значения КСВ до 2
  if (SWR_HI>100) Select=100;                                                       // ограничение максимального значения КСВ до 100
      lcd.print(view[position]); lcd.print(SWR_HI); lcd.print(" ");}                // выводим номер позиции и его значение
  
  if (position==17){                                                                // позиция 17
  if (VOXDelay!=Select) VOXDelay=Select;                                            // если новое значение не равно предыдущему, выравниваем показания
  if (VOXDelay<5)   Select=5;                                                       // ограничение минимального значения времени задержки VOX до 5мс
  if (VOXDelay>100) Select=100;                                                     // ограничение максимального значения времени задержки VOX до 100мс
      lcd.print(view[position]); lcd.print(VOXDelay); lcd.print("msec ");}          // выводим номер позиции и его значение
  
  if (position==18){                                                                // позиция 18
  if (DELAY_SWITCH!=Select) DELAY_SWITCH=Select;                                    // если новое значение не равно предыдущему, выравниваем показания
  if (DELAY_SWITCH<10)  Select=10;                                                  // ограничение минимального значения времени задержки переключение реле диапазонов до 10мс
  if (DELAY_SWITCH>200) Select=200;                                                 // ограничение максимального значения времени задержки переключение реле диапазонов до 200мс
      lcd.print(view[position]); lcd.print(DELAY_SWITCH); lcd.print("ms ");}        // выводим номер позиции и его значение

  if (position==19){                                                                // позиция 19
  if (REFERENCE!=Select) REFERENCE=Select;                                          // если новое значение не равно предыдущему, выравниваем показания
  if (REFERENCE>11) Select=11;                                                      // ограничиваем значение до 11, если больше 11
  if (REFERENCE<0)  Select=0;                                                       // ограничиваем значение до 0, если меньше 0
      lcd.print(view[position]);                                                    // выводим номер позиции
  if (REFERENCE==11) lcd.print("1.1V");                                             // выводим "1.1V", если REFERENCE=11
  else lcd.print("5.0V"); lcd.setCursor(0,3);                                       // иначе выводим "5.0V", курсор в 0,3
       lcd.print("after reboot only!!!");}}                                         // выводим "change after reboot"
  

    EEPROM.update(4, highByte(PWRMax)); EEPROM.update(5, lowByte(PWRMax));          // обновляем новое значение PWRMax
    EEPROM.update(6,PWRStep);                                                       // обновляем новое значение PWRStep
    EEPROM.update(8, highByte(U_ANOD_MAX)); EEPROM.update(9, lowByte(U_ANOD_MAX));  // обновляем новое значение U_ANOD_MAX
    EEPROM.update(10,U_ANOD_ROUND);                                                 // обновляем новое значение U_ANOD_ROUND
    EEPROM.update(12, highByte(I_ANOD_MAX)); EEPROM.update(13, lowByte(I_ANOD_MAX));// обновляем новое значение I_ANOD_MAX
    EEPROM.update(14,I_ANOD_ROUND);                                                 // обновляем новое значение I_ANOD_ROUND
    EEPROM.update(16, highByte(U_GRID2_MAX)); EEPROM.update(17, lowByte(U_GRID2_MAX));// обновляем новое значение U_GRID2_MAX
    EEPROM.update(18,U_GRID2_ROUND);                                                // обновляем новое значение U_GRID2_ROUND
    EEPROM.update(20, highByte(I_GRID_MAX)); EEPROM.update(21, lowByte(I_GRID_MAX));// обновляем новое значение I_GRID_MAX
    EEPROM.update(22,I_GRID_ROUND);                                                 // обновляем новое значение I_GRID_ROUND
    EEPROM.update(24,TIME_ON);                                                      // обновляем новое значение TIME_ON
    EEPROM.update(26,TIME_OFF);                                                     // обновляем новое значение TIME_OFF
    EEPROM.update(28,TIME_LIGHT);                                                   // обновляем новое значение TIME_LIGHT
    EEPROM.update(30,TIME_SLEEP);                                                   // обновляем новое значение TIME_SLEEP
    EEPROM.update(32,STEPmax);                                                      // обновляем новое значение STEPmax
    EEPROM.update(34,UPDATE_BAR);                                                   // обновляем новое значение UPDATE_BAR
    EEPROM.update(36,SWR_HI);                                                       // обновляем новое значение SWR_HI
    EEPROM.update(38,VOXDelay);                                                     // обновляем новое значение VOXDelay
    EEPROM.update(40,DELAY_SWITCH);                                                 // обновляем новое значение DELAY_SWITCH
    EEPROM.update(42,REFERENCE);                                                    // обновляем новое значение REFERENCE
    timer2=0;                                                                       // сбрасываем таймер подсветки
    startLCD(); set_band();                                                         // запускаем индикацию, выводим диапазон
}
//************************************************************************************ Режим приёма команд
void settings_uart() {                                                              // -------------------
  uint8_t numByte;                                                                  // номер принятого байта буфера команды
  config_loop = 1;                                                                  // флаг зацикливания программы в режиме приёма команд
  
while (config_loop) {                                                               // программная петля
  if (uart.available() > 0) {                                                       // проверка буфера UART, если не пустой, то прием команды
    commandByte[numByte] = uart.read();                                             // чтение принятного байта в буфер
  if (commandByte[numByte] == ';') {numByte = 0; decode_command();}                 // проверка окончания команды (';' - терминатор окончания команды) 
  else numByte ++;                                                                  // инкремент номера байта в буфере команды
  if (numByte > 9) { numByte = 0;                                                   // проверка на переполнение буфера команды
  for (uint8_t i = 0; i < 10; i ++) commandByte[i] = 0;}}                           // очистка буфера команды (заполнение нулями)
  
  if (connect_to_pc) {                                                              // проверка флага подключения к внешней программе
    lcd.setCursor(1, 3);                                                            // установка курсора в позицию 2 строка, 1 символ
    lcd.print("Connect Status: OK");                                                // вывод информации на LCD об успешном подключении
    connect_to_pc = 0;}                                                             // сборс флага подключания к внешней программе
}
      delay(3000); lcd.clear(); uart.end();                                         // ожидание 3 сек, очистка LCD, завершение подключения по UART
}
//************************************************************************************ Декодирование команд
void decode_command() {                                                             // ---------------------
  uint16_t addr;                                                                    // адрес ячейки памяти EEPROM
  uint16_t set_data;                                                                // значение ячейки памяти EEPROM
                                                                                    // *** ком. идентификация девайса (принимается и передается для подтверждения установки связи по UART) ***
  if (commandByte[0] == 'I' && commandByte[1] == 'D') {                             // проверка первых 2х принятых байт на соответствие команде
  if (commandByte[2] == ';'){uart.print("ID201;");                                  // проверка окнчания команды, ответ на команду
      connect_to_pc = 1;}}                                                          // поднятие флага успешного подключения по UART 
                                                                                    // *** ком. завершение связи по UART ***
  if (commandByte[0] == 'D' && commandByte[1] == 'I') {                             // проверка первых 2х принятых байт на соответствие команде
  if (commandByte[2] == ';') {uart.print("DI201;");                                 // проверка окнчания команды, ответ на команду
      connect_to_pc = 0; config_loop   = 0;                                         // сброс флагов подключения и зацикливания
      lcd.setCursor(1, 3); lcd.print(" Disconnecting... ");}}                       // вывод информации на LCD о завершении подключения по UART  ****НЕ ОТОБРАЖАЕТСЯ!!!****
                                                                                    // *** ком. очистка памяти ***
  if (commandByte[0] == 'E' && commandByte[1] == 'R') {                             // проверка первых 2х принятых байт на соответствие команде
  if (commandByte[2] == ';') {uart.print("ER1;");                                   // проверка окнчания команды, ответ на команду
  for (uint16_t i = 0; i < 1024; i++) EEPROM[i] = 0xFF;}}                           // цикл очистки памяти EEPROM (все значения в ячейках будут равны (HEX) 0xFF, (BIN) B11111111, (DEC) 255)
                                                                                    // *** ком. запись/чтение ячейки памяти EEPROM ***  
  if (commandByte[0] == 'S' && commandByte[1] == 'T') {addr = 0;                    // проверка первых 2х принятых байт на соответствие команде, очитстка адреса ячейки памяти
    for (uint8_t i = 2; i < 6; i ++) {                                              // обработка принятого адреса ячейки памяти
      addr *= 10;                                                                   // ------------------------
      addr += commandByte[i] - '0';}                                                // ------------------------
      set_data = EEPROM[addr];                                                      // чтение значения из ячейки памяти по указанному адресу
    
  if (commandByte[6] == ';') {                                                      // проверка окончания команды чтения из EEPROM
      if (addr < 10) uart.print("ST000");                                           // передача по UART адреса ячейки памяти
        else if (addr < 100) uart.print("ST00");                                    // ------------------------
          else if (addr < 1000) uart.print("ST0");                                  // ------------------------
            else uart.print("ST");                                                  // ------------------------
      uart.print(addr);                                                             // ------------------------
  if (set_data < 10) uart.print("00");                                              // передача по UART значения ячейки памяти по указанному адресу
  else if (set_data < 100) uart.print("0");                                         // ------------------------
      uart.print(set_data);                                                         // ------------------------
      uart.print(';');}                                                             // передача по UART терминатора (символ окончания команды - ';')
    
  else if (commandByte[9] == ';'){                                                  // проверка окончания команды записи в EEPROM
      set_data = 0;                                                                 // очистка значения переменной
  for (uint8_t i = 6; i < 9; i ++) {                                                // обработка принятого значения ячейки памяти
        set_data *= 10;                                                             // ------------------------
        set_data += commandByte[i] - '0';}                                          // ------------------------
    
  if (EEPROM[addr] != set_data) EEPROM[addr] = set_data;                            // проверка на совпадение предыдущего и нового значения ячейки памяти, при несоответствии - перезапись значания на новое
    if (addr < 10) uart.print("ST000");                                             // передача по UART адреса ячейки памяти
      else if (addr < 100) uart.print("ST00");                                      // ------------------------
        else if (addr < 1000) uart.print("ST0");                                    // ------------------------
          else uart.print("ST");                                                    // ------------------------
      uart.print(addr);                                                             // ------------------------
      if (set_data < 10) uart.print("00");                                          // передача по UART значения ячейки памяти по указанному адресу
        else if (set_data < 100) uart.print("0");                                   // ------------------------
      uart.print(set_data);                                                         // ------------------------
      uart.print(';');}}                                                            // передача по UART терминатора (символ окончания команды - ';')
}                                                                                   // END.
